#ifdef EMULATE_PACKING

/* Input is usually mediump but converted to highp for enough precision up to
 * USHRT_MAX */
highp uint packUnorm2x16Emulated(highp vec2 v) {
    highp uvec2 expanded = uvec2(round(clamp(v, 0.0, 1.0)*65535.0));
    return (expanded.x & 0xffffu) | (expanded.y << 16u);
}

highp uint packSnorm2x16Emulated(highp vec2 v) {
    /* GLSL int -> uint cast preserves the bit pattern */
    highp uvec2 expanded = uvec2(ivec2(round(clamp(v, -1.0, 1.0)*32767.0)));
    return (expanded.x & 0xffffu) | (expanded.y << 16u);
}

#define packUnorm2x16 packUnorm2x16Emulated
#define packSnorm2x16 packSnorm2x16Emulated

#endif

highp uvec2 packUnormVector(mediump vec4 v) {
    return uvec2(
        packUnorm2x16(v.xy),
        packUnorm2x16(v.zw)
    );
}

highp uvec2 packSnormVector(mediump vec4 v) {
    return uvec2(
        packSnorm2x16(v.xy),
        packSnorm2x16(v.zw)
    );
}
